divert(-1)
dnl
dnl Updates: http://anfi.homeunix.net/sendmail/rtcyrus2.html
dnl
dnl By using this file, you agree to the terms and conditions set
dnl forth in the LICENSE file which can be found at the top level of
dnl the sendmail distribution (sendmail-8.12).
dnl
dnl	Contributed by Andrzej Filip
dnl
dnl $Log: mrs_cyrus.m4,v $
dnl Revision 1.1  2007/04/16 20:37:35  anfi
dnl First version in  sourceforge CVS
dnl
dnl Revision 8.9  2005/01/24 19:44:53  anfi
dnl Fixed handling of empty relay
dnl
dnl Revision 8.8  2004/08/11 18:20:05  anfi
dnl "stipdom" replaced by "dummy"
dnl
dnl Revision 8.7  2004/04/01 14:29:50  anfi
dnl Added "stripdom" handling in mrs_cyrus_user.
dnl Fully defined error mailer details.
dnl
dnl Revision 8.6  2004/03/18 23:17:57  anfi
dnl Fundamental rewrite.
dnl
ifdef(`_MRS_RELAY_',`',
        `errprint(`*** ERROR: FEATURE(mrs_cyrus) requires FEATURE(mrs)
')')
ifdef(`_MRS_CYRUS_',
        `errprint(`*** ERROR: There can be only one FEATURE(mrs_cyrus*)
')')
define(`_MRS_CYRUS_',`')

divert(0)
VERSIONID(`$Id: mrs_cyrus.m4,v 1.1 2007/04/16 20:37:35 anfi Exp $')
divert(-1)
define(`CYRUS_SMMAPD_SOCKET',
        ifelse(len(X`'_ARG_), `1', `/var/imap/socket/smmapd', _ARG_))
define(`CYRUS_SMMAPD_SOCKET_TYPE',
        ifelse(len(X`'_ARG2_), `1', `local', _ARG2_))
LOCAL_CONFIG
# Add 3 mrs_cyrus rule sets to list of valid mrs rule sets
C{MRS}mrs_cyrus_user mrs_cyrus_mailertable mrs_cyrus_stickyhub
# map for checking cyrus imap mailbox existence 
Kcyrus socket -a<OK> -T<TMPF> CYRUS_SMMAPD_SOCKET_TYPE:CYRUS_SMMAPD_SOCKET

LOCAL_RULESETS
######################################################################
### feature mrs_cyrus rulesets to be used by feature mrs
######################################################################

Smrs_cyrus_user
R<$*> $+ <@$+.>			$: <$1> $2 <@ $3 >
R<$*> $+ <@$*>			$: <$1> $2 <@$3> $| $(cyrus $2 $: $)
R<$*> $+ <@$*> $| $* <TMPF>	$# error $@ 4.3.0 $: "451 Temporary system failure. Please try again later."
R<$*> $+ <@$*> $| $* <OK>	$# cyrusv2 $@ dummy $: $4
R<$*> $+ <@$*> $| $*		$: <$1> $2 <@$3>
R<dummy> $+ <@dummy>	$@ $1
R< > $*				$# error $@ 5.1.1 $: "550 User unknown"
R< $~[ : $* > $*		$>MailerToTriple < $1 : $2 > $3
R< $+ > $*			$>MailerToTriple < $1 > $2

Smrs_cyrus_mailertable
R<$*> $+ <@$+.>			$: <$1> $2 <@ $3 >
R<$*> $+ <@$+> 			$: <$1> $2 <@$3> $| $(cyrus $2@$3 $: $)
R<$*> $+ <@$+> $| $* <TMPF>	$# error $@ 4.3.0 $: "451 Temporary system failure. Please try again later."
R<$*> $+ <@$+> $| $* <OK>	$# cyrusv2d $@ dummy $: $2 <@$3>
R<$*> $+ <@$*> $| $*		$: <$1> $2 <@$3>
R< > $*				$# error $@ 5.1.1 $: "550 User unknown"
R< $~[ : $* > $*		$>MailerToTriple < $1 : $2 > $3
R< $+ > $*			$>MailerToTriple < $1 > $2

Smrs_cyrus_stickyhub
R<dummy> $+ <@$+.>		$: <dummy> $1 <@ $2 >
R<dummy> $* <@dummy>		$@ $1
R<dummy> $+ <@$={VirtCyrus}> 	$: <dummy> $1 <@$2> $| $(cyrus $1@$2 $: $)
R<dummy> $+ <@$={VirtCyrus}> $| $* <TMPF>	$# error $@ 4.3.0 $: "451 Temporary system failure. Please try again later."
R<dummy> $+ <@$={VirtCyrus}> $| $* <OK>		$# cyrusv2d $@ dummy $: $1 <@$2>
R<dummy> $+ <@$={VirtCyrus}> $| $*		$# error $@ 5.1.1 $: "550 User unknown"
R<dummy> $=L <@$*>		$# ifdef(`confLOCAL_MAILER',confLOCAL_MAILER,`local') $: @$1
R<dummy> $* <@$*>		$# ifdef(`confLOCAL_MAILER',confLOCAL_MAILER,`local') $: $1
